const thoffset = 20;

function toggleTab(i) {
	switch (i) {
		case 0 : preferences.JobVis.value = preferences.JobVis.value=="1" ? "0" : "1"; break;
		case 1 : preferences.SelfVis.value = preferences.SelfVis.value=="1" ? "0" : "1"; break;
		case 2 : preferences.ParentVis.value = preferences.ParentVis.value=="1" ? "0" : "1"; break;
		case 3 : preferences.SpouseVis.value = preferences.SpouseVis.value=="1" ? "0" : "1"; break;
		case 4 : preferences.FriendVis.value = preferences.FriendVis.value=="1" ? "0" : "1"; break;
		case 5 : preferences.FamilyVis.value = preferences.FamilyVis.value=="1" ? "0" : "1"; break;
		case 6 : preferences.PossessionsVis.value = preferences.PossessionsVis.value=="1" ? "0" : "1";
	} // end switch
	tabs.setHighlight(i, roleVis(rolesData[i]));
	redraw();
} // end toggleTab

function Tabs(titles) {
	this.tab = new Array;
	this.text = new Array;
	this.shadow = new Array;
	for (var i=0; i<titles.length; i++) {
		this.tab[i] = new Image();
		this.tab[i].visible = false;
		main_window.root.addSubview(this.tab[i]);
		this.tab[i].src = "Resources/tab.png";
		this.tab[i].hOffset = i * (this.tab[i].srcWidth - thoffset) + 1;
		this.text[i] = new Text();
		this.text[i].visible = false;
		main_window.root.addSubview(this.text[i]);
		this.text[i].bgOpacity = 0;
		this.text[i].size = 12;
		this.text[i].hAlign = "center";
		this.text[i].hOffset = this.tab[i].hOffset + this.tab[i].srcWidth/2 - 5;
		if (titles[i].indexOf("-") < 0)
			this.text[i].data = titles[i];
		else
			this.text[i].data = titles[i].split("-")[0];
		this.shadow[i] = this.text[i].shadow = new Shadow();
		this.shadow[i].hOffset = this.shadow[i].vOffset = 1;
		this.text[i].onMouseUp = this.tab[i].onMouseUp = "toggleTab("+i+");";
		this.text[i].tooltip = this.tab[i].tooltip = titles[i] + " is " + (roleVis(titles[i])?"being displayed":"not displayed") + "\nright-click on any tab to select show/hide role names";
	} // end for
	this.height = this.tab[0].height;
	this.width = this.tab[this.tab.length-1].hOffset + this.tab[this.tab.length-1].width;
	// end constructor code

	this.setContextMenu = function() {
		var items = new Array();
		items[0] = new MenuItem();
		items[0].title = (preferences.ShowRole.value == "1") ? "Hide role names" : "Show role names";
		items[0].enabled = true;
		items[0].checked = false;
		items[0].onSelect = "toggleRolenamesVis()";
		items[1] = new MenuItem();
		items[1].title = "Hide role visibility tabs";
		items[1].enabled = true;
		items[1].checked = false;
		items[1].onSelect = "preferences.ShowTabs.value = \"0\";tabs.setVisibility(false)";
		for (var i=0; i<this.tab.length; i++)
			this.text[i].contextMenuItems = this.tab[i].contextMenuItems = items;
	} // end updateContext

	this.setVisibility = function(vis) {
		for (var i=0; i<this.tab.length; i++)
			this.tab[i].visible = this.text[i].visible = vis;
	} // end setVisibility

	this.setVoffset = function(v) {
		for (var i=0; i<this.tab.length; i++) {
			this.tab[i].vOffset = v;
			this.text[i].vOffset = v + this.tab[i].srcHeight/2;		} // end for
	} // end setVoffset

	this.setHighlight = function(i, yn) {
		this.text[i].color = yn ? roleColor(i) : "#000000";
		this.shadow[i].color = yn ? "#000000" : roleColor(i);
		// the following should be unnecessary, but required to change shadow color
		this.text[i].shadow = this.shadow[i];
		this.tab[i].hslAdjustment = yn ? null : "0,0,-40";
		this.text[i].tooltip = this.tab[i].tooltip = titles[i] + " is " + (roleVis(titles[i])?"being displayed":"not displayed") + "\nright-click on any tab to select show/hide role names";
	} // end setHighlight

	// constructor code that uses member functions

	this.setContextMenu();

} // end Tabs